##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic compression utilities                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate the generation of          ##
## compressed files and their inclusion in users' projects.               ##
############################################################################

## COMPRESSION EXAMPLE (Uncomment lines to use)
##

## First 3 calls to ADD2PACK add enemy, hero and background
## graphics (previously converted to binary data) into the 
## compressed group 'mygraphics'. After that, call to PACKZX7B
## compresses all the data and generates an array with the result
## that is placed in src/mygraphics.c & src/mygraphics.h, ready
## to be included and used by other modules.
##
#$(eval $(call ADD2PACK,mygraphics,gfx/enemy.bin))
#$(eval $(call ADD2PACK,mygraphics,gfx/hero.bin))
#$(eval $(call ADD2PACK,mygraphics,gfx/background.bin))
#$(eval $(call PACKZX7B,mygraphics,src/))

$(eval $(call ADD2PACK,level_01_pack,src/assets/tiles/level_01.bin))
$(eval $(call PACKZX7B,level_01_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_02_pack,src/assets/tiles/level_02.bin))
$(eval $(call PACKZX7B,level_02_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_03_pack,src/assets/tiles/level_03.bin))
$(eval $(call PACKZX7B,level_03_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_04_pack,src/assets/tiles/level_04.bin))
$(eval $(call PACKZX7B,level_04_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_05_pack,src/assets/tiles/level_05.bin))
$(eval $(call PACKZX7B,level_05_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_06_pack,src/assets/tiles/level_06.bin))
$(eval $(call PACKZX7B,level_06_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_07_pack,src/assets/tiles/level_07.bin))
$(eval $(call PACKZX7B,level_07_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_08_pack,src/assets/tiles/level_08.bin))
$(eval $(call PACKZX7B,level_08_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_09_pack,src/assets/tiles/level_09.bin))
$(eval $(call PACKZX7B,level_09_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_10_pack,src/assets/tiles/level_10.bin))
$(eval $(call PACKZX7B,level_10_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_11_pack,src/assets/tiles/level_11.bin))
$(eval $(call PACKZX7B,level_11_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_12_pack,src/assets/tiles/level_12.bin))
$(eval $(call PACKZX7B,level_12_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_13_pack,src/assets/tiles/level_13.bin))
$(eval $(call PACKZX7B,level_13_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_14_pack,src/assets/tiles/level_14.bin))
$(eval $(call PACKZX7B,level_14_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_15_pack,src/assets/tiles/level_15.bin))
$(eval $(call PACKZX7B,level_15_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_16_pack,src/assets/tiles/level_16.bin))
$(eval $(call PACKZX7B,level_16_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_17_pack,src/assets/tiles/level_17.bin))
$(eval $(call PACKZX7B,level_17_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_18_pack,src/assets/tiles/level_18.bin))
$(eval $(call PACKZX7B,level_18_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_19_pack,src/assets/tiles/level_19.bin))
$(eval $(call PACKZX7B,level_19_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_20_pack,src/assets/tiles/level_20.bin))
$(eval $(call PACKZX7B,level_20_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_21_pack,src/assets/tiles/level_21.bin))
$(eval $(call PACKZX7B,level_21_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_21bis_pack,src/assets/tiles/level_21bis.bin))
$(eval $(call PACKZX7B,level_21bis_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_22_pack,src/assets/tiles/level_22.bin))
$(eval $(call PACKZX7B,level_22_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_23_pack,src/assets/tiles/level_23.bin))
$(eval $(call PACKZX7B,level_23_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_24_pack,src/assets/tiles/level_24.bin))
$(eval $(call PACKZX7B,level_24_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_25_pack,src/assets/tiles/level_25.bin))
$(eval $(call PACKZX7B,level_25_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_26_pack,src/assets/tiles/level_26.bin))
$(eval $(call PACKZX7B,level_26_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_27_pack,src/assets/tiles/level_27.bin))
$(eval $(call PACKZX7B,level_27_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_28_pack,src/assets/tiles/level_28.bin))
$(eval $(call PACKZX7B,level_28_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_29_pack,src/assets/tiles/level_29.bin))
$(eval $(call PACKZX7B,level_29_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_30_pack,src/assets/tiles/level_30.bin))
$(eval $(call PACKZX7B,level_30_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_31_pack,src/assets/tiles/level_31.bin))
$(eval $(call PACKZX7B,level_31_pack,src/assets/tiles/compressed_tiles/))

$(eval $(call ADD2PACK,level_32_pack,src/assets/tiles/level_32.bin))
$(eval $(call PACKZX7B,level_32_pack,src/assets/tiles/compressed_tiles/))


$(eval $(call ADD2PACK,screenmenu_z,src/assets/screens/menuScreenV2.bin))
$(eval $(call PACKZX7B,screenmenu_z,src/assets/screens/))

$(eval $(call ADD2PACK,screenend_z,src/assets/screens/endScreen.bin))
$(eval $(call PACKZX7B,screenend_z,src/assets/screens/))

############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macros used for compression are ADD2PACK and PACKZX7B:                 ##
##                                                                        ##
##	ADD2PACK: Adds files to packed (compressed) groups. Each call to this ##
##  		  macro will add a file to a named compressed group.          ##
##  PACKZX7B: Compresses all files in a group into a single binary and    ##
##            generates a C-array and a header to comfortably use it from ##
##            inside your code.                                           ##
##                                                                        ##
##------------------------------------------------------------------------##
##                                                                        ##
##  $(eval $(call ADD2PACK,<packname>,<file>))                            ##
##                                                                        ##
##		Sequentially adds <file> to compressed group <packname>. Each     ##
## call to this macro adds a new <file> after the latest one added.       ##
## packname could be any valid C identifier.                              ##
##                                                                        ##
##  Parameters:                                                           ##
##  (packname): Name of the compressed group where the file will be added ##
##  (file)    : File to be added at the end of the compressed group       ##
##                                                                        ##
##------------------------------------------------------------------------##
##                                                                        ##
##  $(eval $(call PACKZX7B,<packname>,<dest_path>))                       ##
##                                                                        ##
##		Compresses all files in the <packname> group using ZX7B algorithm ##
## and generates 2 files: <packname>.c and <packname>.h that contain a    ##
## C-array with the compressed data and a header file for declarations.   ##
## Generated files are moved to the folder <dest_path>.                   ##
##                                                                        ##
##  Parameters:                                                           ##
##  (packname) : Name of the compressed group to use for packing          ##
##  (dest_path): Destination path for generated output files              ##
##                                                                        ##
############################################################################
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##  * You can omit parameters by leaving them empty.                      ##
##  * Parameters (4) and (5) are optional and generally not required.     ##
############################################################################
